/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/emap_Cwray.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 */

#include <cstdio>

#include "blkdta.h"
#include "wray.h"
#include "blob.h"
#include "consts.h"
#include "uiod.h"

#include "emap.h"

BOOLEAN emap_class::findqpart(INTEGER np, INTEGER nr, REAL yi, REAL* recon,
		REAL* qtilde)
{
	//----- local variables
	INTEGER t, nt, bigT, n[4096];
	REAL l[4096], snorm, si;

	//------ Body of outer loop in Algorithm FIND_q~ for the MAP algorithm * /

	if (Blob.pix_basis)
	{
		wray(np, nr, n, l, &bigT, &snorm);
	}
	else
	{
		Blob.bwray(np, nr, n, l, &bigT, &snorm); // l and n must have enough size for blob basis. Why 4096? Hstau 6/25/2003
	}

	if (bigT != 0)
	{
		si = 0.0;
		for (t = 0; t < bigT; t++)
		{
			si += recon[n[t]] * l[t];
		}

		if (si < Consts.zero)
		{
			fprintf(output,
					"\n****The pseudo raysum for  np = %d, nr = %d is zero, EMAP is not applicable, EMAP aborted!\n",
					np, nr);
			return TRUE;
		}                                                  //added by wei 1/2005

		//cvd$     nodepchk
		for (t = 0; t < bigT; t++)
		{
			nt = n[t];
			qtilde[nt] += yi / si * l[t];
		}
	}

	return FALSE;
}
