/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/foru_store.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************


 PURPOSE: GIVEN THE COORDINATES OF A POINT (IX,IY) AND THE VALUE
 AT THE POINT (GR,GI) ,WHERE GR IS THE REAL PART AND
 GI IS THE IMAGINARY PART, STORE THE VALUE IN THE
 APPROPRIATE PLACE IN THE COMMON BLOCK STARTING AT
 NFRPLN+1
 */

#include <cstdio>
#include <cmath>

#include "blkdta.h"
#include "fourie.h"
#include "consts.h"
#include "uiod.h"

#include "foru.h"

void foru_class::store(INTEGER ix, INTEGER iy, REAL gr, REAL gi)
{

	REAL y;
	REAL x;
	INTEGER i;
	INTEGER j;
	INTEGER npos;

	y = (REAL) iy;
	x = (REAL) ix;

// FILTERING

	if (ix < 0)
	{

		// IX LT 0  THE POINT IS ON THE LEFT HALF PLANE, FIND THE POINT
		// WHICH IS CONGRUENT TO IT W.R.T. ORIGIN. THE VALUE AT THAT POINT
		// IS (GR,-GI)

		i = -ix;
		j = -iy;
		if (j < 0)
			j += Fourie.nsize2;
		npos = j * (Fourie.nsize2 + 2) + 2 * i;
		Fourie.nfrpln[npos] = gr;
		Fourie.nfrpln[npos + 1] = -gi;
		return;
	}

	// IX EQ 0  THE POINT IS ON THE Y AXIS, WE NEED POINTS ON BOTH SIDES
	// OF ORIGIN

	else if (ix == 0)
	{
		i = 0;
		j = iy;
		if (j < 0)
			j += Fourie.nsize2;
		npos = j * (Fourie.nsize2 + 2) + 2 * i;
		Fourie.nfrpln[npos] = gr;
		Fourie.nfrpln[npos + 1] = gi;
		i = 0;
		j = -iy;
		if (j < 0)
			j += Fourie.nsize2;
		npos = j * (Fourie.nsize2 + 2) + 2 * i;
		Fourie.nfrpln[npos] = gr;
		Fourie.nfrpln[npos + 1] = -gi;
		return;
	}
	else
	{
		// IX GT 0  THE POINT IS ON THE RIGHT HALF PLANE

		i = ix;
		j = iy;
		if (j < 0)
			j += Fourie.nsize2;
		npos = j * (Fourie.nsize2 + 2) + 2 * i;
		Fourie.nfrpln[npos] = gr;
		Fourie.nfrpln[npos + 1] = gi;
		return;
	}
}
