/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/getang.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 
 RETURN VALUES OF THETA, SINTH AND COSTH FOR PROJECTION NP.
 */

#include <cstdio>
#include <cstdlib>
#include <cmath>

#include "blkdta.h"
#include "geom.h"
#include "uiod.h"

#include "anglst.h"

void anglst_class::getang(INTEGER np, REAL* theta, REAL* sinth, REAL* costh)
{
	if ((np >= 0) && (np < GeoPar.prjnum))
	{
		*theta = bth[np];
		*sinth = bsin[np];
		*costh = bcos[np];
		return;
	}
	// NP IS OUT OF RANGE
	fprintf(output,
			"\n **** getang called with invalid projection number: np = %5i",
			np);
	fprintf(output, "\n **** program aborted\n");
	exit(-1);
}
