/* 
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/inputfile.h $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#ifndef INPUTFILE_H
#define INPUTFILE_H

#define DATASIZ 256

//jk 11/18/2007 introducing variability
extern REAL variability;
//jk 02/06/09 bug 251
//extern long newseed;  //the variable Creacm.varseed is used instead
//the array stores values of variability added to each pixel of the phantom
extern REAL * variab_array[7];
//the flag is set if the value of variability in the input file is other than zero
extern BOOLEAN variab_set;
//saves the value of the origical scale which is the mean value for variability calculations
extern REAL mean;

extern REAL * phantom_poly_array[7];

class InputFile_class
{
protected:

	FILE* infile;
	INTEGER word;

	INTEGER ptr;
	CHAR data[DATASIZ + 2];     // bug 190 - swr - 12/09/05

public:
	void Open();
	void GetName();
	void ReadEnergySpectralDistribution();
	void GetInformationABoutCreationOfPhantom(INTEGER invoke);
	void ReadBackgroundAbsorption();
	void ReadRaysumInformation();
	void ReadGeometryData(INTEGER invoke);
	void ReadNumberOfRaysAndRaySpacing(INTEGER invoke);

	void ReadProjectionAngles(BOOLEAN f11);
	void GetMesurementStatistics();
	void ReadIfoForComputionRaysums();
	void ReadObjects(INTEGER invoke);

	REAL getnum(BOOLEAN NewLine, BOOLEAN* eol);
	// removed old (2-parameter) version of getwrd. Lajos, Dec 16, 2004
	INTEGER getwrd(BOOLEAN NewLine, BOOLEAN* eol, const INTEGER *expect,
			int nexpect);
	INTEGER getint(BOOLEAN NewLine, BOOLEAN* eol);
	void getnxt(BOOLEAN flag, BOOLEAN newline = TRUE);

	void echoline(BOOLEAN flag);  // added by Lajos, Jan 25, 2005
};

#endif
