/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/pnch.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 POST-PROCESSING ROUTINE TO OUTPUT RECONSTRUCTIONS IN THE SNARK
 PICTURE FORMAT.
 */

#include <cstdlib>
#include <cstdio>

#include "blkdta.h"
#include "uiod.h"

#include "recfile.h"
#include "pnchfile.h"
#include "infile.h"

#include "post.h"

#include "pnch.h"

void pnch()
{
	// was in post but it is really local
	CHAR prjnam[81];
	CHAR phnnam[81];
	CHAR recnam[81];

	// was in geo but it is realy local
	INTEGER nelem;
	INTEGER area;

	//commented out since it is never used. Lajos, Dec 16, 2004
	static const INTEGER hphan = CHAR2INT('p', 'h', 'a', 'n');

	// modified calls to getwrd() to use the 4-parameter version. Lajos, Dec 13, 2004
	static const INTEGER pnch_codes[1] =
	{ CHAR2INT('p', 'h', 'a', 'n') };

	BOOLEAN eol, phan;
	INTEGER flags[51];
	CHAR algn[5];
	unsigned INTEGER count, iter;
	REAL* recon;

	static bool called = FALSE;

	// if first time call open new punch file
	if (!called)
	{
		if (PunchFile.Open(false) != 0)
		{
			fprintf(output, "\n **** unable to open file: punch");
			fprintf(output, "\n **** PUNCH execution aborted\n");
			return;
		}
		called = true;
	}
	else
	{ // otherwise append
		if (PunchFile.Open(true) != 0)
		{
			fprintf(output, "\n **** unable to open file: punch");
			fprintf(output, "\n **** PUNCH execution aborted\n");
			return;
		}
	}

	if (RecFile.Open("recfil") != 0)
	{
		fprintf(output, "\n **** unable to open file: punch");
		fprintf(output, "\n **** PUNCH execution aborted\n");
		PunchFile.Close();
		return;
	}

	if (RecFile.GetNelem(&nelem) != 0)
	{
		;
	}

	if (RecFile.GetProjName(prjnam) != 0)
	{
		;
	}

	area = nelem * nelem;

	phan = (InFile.getwrd(FALSE, &eol, pnch_codes, 1) == hphan);

	InFile.listit(flags);

	recon = new REAL[area];

	if (phan)
	{
		if (RecFile.ReadPhan(phnnam, recon) != 0)
		{
			fprintf(output, "\n **** phantom not present\n");
		}
		else
		{
			PunchFile.WritePhantomHeader(phnnam);

			PunchFile.WriteData(recon, nelem);
		}
	}

	prjnam[30] = 0;

	while (RecFile.ReadRec(recnam, algn, &count, &iter, recon) == 0)
	{

		recnam[30] = 0;

		if (flags[iter - 1] != 0)
		{

			fprintf(output,
					"\n          reconstruction of %4s using %s iter %5i,   %s",
					recnam, algn, count, prjnam);

			PunchFile.WriteRecHeader(recnam, algn, count, prjnam);

			PunchFile.WriteData(recon, nelem);
		}
	}

	delete[] recon;  // bug 92 - Lajos - 03/02/2005

	RecFile.Close();
	PunchFile.Close();
}

