 /* 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                                                           *
 *                              S N A R K   1 4                              *
 *                                                                           *
 *                     A PICTURE RECONSTRUCTION PROGRAM                      *
 *                                                                           *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

 quad.h,v 1.7 2009/09/26 14:54:43 jklukowska Exp
*/

#ifndef XALG8_H
#define XALG8_H      

#include "alg.h"

///      common /quad/ aopt,bopt,copt,dopt,eopt,fopt,gopt,hopt,popt,
///     1 l,bw1,bw2,bw3,bbcon,t,cw1,cw2,cw3,cbcon,sa,sb,sc,xbar,error,
///     2 iterx,period,z,eta,del,order
///      integer aopt,bopt,copt,dopt,eopt,fopt,gopt,hopt,popt,l,bbcon,
///     1 t,cbcon,iterx,period,del,order
///      real bw1,bw2,bw3,cw1,cw2,cw3,sa,sb,sc,xbar,error,z,eta

/*
class quad_class
{
public:
  INTEGER aopt,bopt,copt,dopt,eopt,fopt,gopt,hopt,popt,l,bbcon;
  INTEGER t,cbcon,iterx,period;
  REAL* del;
  INTEGER* order;

  REAL bw1,bw2,bw3,cw1,cw2,cw3,sa,sb,sc,xbar,error_1,z,eta;
};
*/

class quad_class: public alg_class
{
private:
  //quad_class Quad;

  INTEGER aopt,bopt,copt,dopt,eopt,fopt,gopt,hopt,popt,l,bbcon;
  INTEGER t,cbcon,iterx,period;
  REAL* del;
  INTEGER* order;


  REAL* cg_;
  REAL* g_;
  REAL* v_;
  REAL* w_;
  REAL* r_;
  REAL* f_;
  REAL* fb_;
  REAL* s_;
  REAL* d_; 
  REAL* m;
  REAL* n;                //wei,3/2005
 	
  REAL bw1,bw2,bw3,cw1,cw2,cw3,sa,sb,sc,xbar,error_1,z,eta;

  void deltac(
    REAL* r,
    REAL* g,
    REAL* v,
    REAL* cg,
    REAL* w,
    //REAL delta,
    //REAL gma,
    REAL* delta,   //corr. hstau
    REAL* gma,     //corr. hstau
    INTEGER* list,
    REAL* weight,
    BOOLEAN* alg,
    REAL* s
  );

  void deltad(
    REAL* r,
    REAL* g,
    REAL* v,
    REAL* cg,
    REAL* d,
    //REAL delta, 
    //REAL gma,
    REAL* delta,   //corr. hstau
    REAL* gma,     //corr. hstau
    INTEGER* list,
    REAL* weight,
    BOOLEAN *alg
  );

  void eigval(
    REAL* y,
    BOOLEAN nomin,
    REAL* d,
    INTEGER* list,
    REAL* weight,
    REAL tol,
    REAL* estmin,  //corr.hstau
    REAL* lambda,  //corr.hstau
    //REAL estmin,
    //REAL lambda,
    REAL* s
  );

  void matrix(REAL* y, REAL* x, REAL* d, INTEGER* list, REAL* weight, REAL* s);
  void mtamx(REAL* x, REAL* y, INTEGER* list, REAL* weight);
  void costfn(REAL* recon, REAL* r, REAL* g, REAL* cg, REAL* w, INTEGER* list, REAL* weight, REAL* f);
  void resedu(REAL* x, REAL* r, REAL* w, REAL* d, INTEGER* list, REAL* weight, REAL* f, REAL* s);
  void adsmos(REAL* x, INTEGER m, REAL w1, REAL w2, REAL w3, INTEGER bcon);
  void badsmos(REAL* x, INTEGER m, REAL w1, REAL w2, INTEGER bcon);  // blob version of adsmos
  void mtamxp(REAL* x, REAL* y, INTEGER* list, REAL* weight);
  void semi(REAL* delta, REAL* gma, BOOLEAN* alg);
  void prsemi(REAL estmin, REAL lambda, BOOLEAN* alg, REAL* delta);
  void deset(REAL* d, INTEGER* list, REAL* weight, BOOLEAN* alg);
  void nxtpct(REAL* x, REAL* cg, REAL delta);
  REAL uerror(INTEGER np, INTEGER nr, REAL pd, BOOLEAN* alg);
  void sset(REAL* s, INTEGER* list, REAL* weight, BOOLEAN* alg);
  void seset(REAL* s, INTEGER* list, REAL* weight, BOOLEAN* alg);
  void dset(REAL* d, INTEGER* list, REAL* weight, BOOLEAN* alg);
  void back(REAL* x, INTEGER* list, REAL* weight);
  void blurck(REAL b1, REAL b2, REAL b3, INTEGER bcon, INTEGER npow, BOOLEAN* alg1);
  void nextr(REAL* r, REAL* v, REAL delta, INTEGER area);
  void prpict(INTEGER n, REAL* x, INTEGER it, const CHAR* l, const CHAR* m);
  void bprpict(INTEGER M, INTEGER H, REAL* x, INTEGER it, const CHAR* l, const CHAR* m); // blob version of prpict

public:
  BOOLEAN Run(REAL* recon, INTEGER* list, REAL* weight, INTEGER iter);
  INTEGER Init();
  INTEGER Reset();
};

#endif      
