/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/sec_cri1.cpp $
 $LastChangedRevision: 107 $
 $Date: 2014-07-07 12:06:15 -0400 (Mon, 07 Jul 2014) $
 $Author: olangthaler $
 ***********************************************************
 */

#include "sec_cri1.h"
#include "math.h"
#include "anglst.h"
#include "blob.h"

using namespace std;

REAL sec_cri1_class::Run(REAL* image)
{
	INTEGER dimensions = GeoPar.nelem;
	// pixels over which to iterate (skip last line and new bottom right pixel)
	INTEGER pixelcount = GeoPar.area - dimensions - 2;

	REAL tau = 0;
	for (INTEGER i = 1; i < pixelcount; i++)
	{
		// skip right-most column
		if (i % (dimensions) == 0) continue;

		tau += sqrt(pow(image[i - 1] - image[i - 1 + dimensions], 2) + pow(image[i - 1] - image[i], 2));
	}

	return tau;
}
