/** @file chooseRanges.hpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef CHOOSERANGES_H
#define CHOOSERANGES_H

#include "variables.hpp"
#include "displaywidget.hpp"

#include <qdialog.h>

#include <qbuttongroup.h>
#include <qcolor.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qfiledialog.h>
#include <qfont.h>
#include <qframe.h>
#include <qimage.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qpen.h>
#include <qpixmap.h>
#include <qpoint.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qtooltip.h>
#include <qvariant.h>
#include <qwhatsthis.h>
#include <qwidget.h>

class QVBoxLayout;
class QHBoxLayout;
class QButtonGroup;
class QCheckBox;
class QComboBox;
class QFrame;
class QGridLayout; 
class QLabel;
class QLineEdit;
class QListBox;
class QListBoxItem;
class QPushButton;
class QRadioButton;
class QPixmap;

class chooseRangesDialog : public QDialog
{
  Q_OBJECT

public:
  chooseRangesDialog( QWidget* parent=0, const char* name=0, bool modal=true, WFlags fl=0, int x=0 , int y=0, 
		      unsigned ee_index=0, bool forPBP=0, unsigned PBPYVar=0, globalYVar_t GlobalYVar=VARIANCE,
		      int minX=0, int maxX=0, double minY= -1.0, double maxY= -1.0);
  ~chooseRangesDialog();
  int id;
  bool status;
  //  double maxval,minval,diffmaxval,diffminval;
  QString YVarName;
  QString fullname;
  displayWidget* displaywidget;
  QBoxLayout* topLayout;
  //  QBoxLayout* yaxisbuttonLayout;
  QBoxLayout* x_extrema_layout;
  QBoxLayout* y_extrema_layout;
  //  QButtonGroup* yaxisbuttongroup;
  QLabel* minxlabel;
  QLabel* maxxlabel;
  QLabel* minylabel;
  QLabel* maxylabel;
  QLineEdit* minx;
  QLineEdit* maxx;
  QLineEdit* miny;
  QLineEdit* maxy;
  QPushButton* plotbutton;
  QPushButton* closebutton;
private:
  unsigned ee_index;
  bool forPBP; // as opposed to forGlobal
  unsigned PBPYVar;
  globalYVar_t GlobalYVar;
public slots:
  void proceed();
  void closeWindow();
protected:
  virtual void closeEvent(QCloseEvent *e);
};
#endif // CHOOSERANGES_H
