/** @file openimages.hpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef OPENIMAGESWINDOW_H
#define OPENIMAGESWINDOW_H

#include <qvariant.h>
#include <qdialog.h>
#include <qwidget.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QFrame;
class QListBox;
class QListBoxItem;
class QPushButton;
class SnarkDisplay;
class displaywindow;
// class openimageswindow : public QDialog
class openimageswindow : public QWidget
{ 
    Q_OBJECT

public:
    openimageswindow( displaywindow** displaywindowset_in, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 , int x = 0 , int y = 0 );
    ~openimageswindow();

    QWidget* Parent;
    QFrame* Line6;
    QListBox* imageslistbox;
    QPushButton* openbutton;
    QPushButton* selectbutton;
    QPushButton* clearselectbutton;
    QPushButton* closebutton;
private:
    displaywindow** displaywindowset;
public slots:
    void openImages();
    void setImagesNames();
    void selectAll();
    void clearSelected();
    void closeWindow() { hide(); }
    void closeEvent(QCloseEvent* e) { closeWindow(); }
};

#endif // OPENIMAGESWINDOW_H
