/** @file range.hpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef RANGEWINDOW_H
#define RANGEWINDOW_H

#include <qvariant.h>
#include <qdialog.h>
class QCheckBox;
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QFrame;
class QLabel;
class QLineEdit;
class QPushButton;
class QSlider;

class rangewindow : public QDialog
{ 
    Q_OBJECT

public:
    rangewindow( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~rangewindow();

    bool status;
    double maxval,minval,Range;
  //    QPushButton* selectbutton;
  //    QPushButton* clearselectbutton;
    QCheckBox* allGlobals;
    QCheckBox* allDifference;
    QCheckBox* allIntensity;
    QFrame* lowtrheshframe;
    QLineEdit* lowthresh;
    QPushButton* setlowbutton;
    QSlider* lowthreshslider;
    QLabel* lowthershlabel;
    QFrame* highthreshframe;
    QLineEdit* highthresh;
    QPushButton* sethighbutton;
    QSlider* highthreshslider;
    QLabel* highthreshlabel;
    QFrame* Line2;
  //    QPushButton* applybutton;
    QPushButton* closebutton;
  public slots:
    void updateLowthresh();
    void updateLowthreshslider();
    void updateHighthresh();
    void updateHighthreshslider();
    void signalAllGlobals(bool on);
    void signalAllDifference(bool on);
  //    void signalAllIntensity();
    void closeWindow();
    void closeEvent(QCloseEvent* e);
};

#endif // RANGEWINDOW_H
