/** @file create.h
    @package snark14Input
    @author Bruno M. Carvalho and Deniz Sarioz
    modified by Joanna Klukowska (June 2008)
	added two fields in LAST line for agreement with snark14
	removed SAVE and MODIFY options of Run since snark14 does not have file12
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef CREATEWINDOW2_H
#define CREATEWINDOW2_H

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QLabel;
class QComboBox;
class QLineEdit;
class QMultiLineEdit;
class QComboBox;
class QPushButton;
class QRadioButton;
class QTabWidget;
class QWidget;
class QFrame;
class QCheckBox;

class createwindow : public QDialog
{ 
    Q_OBJECT

public:
    createwindow( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~createwindow();
    QString getOutput1();
    QString getOutput2();
    QString getOutput3();
    QString getOutput4();
    QString getOutput5();
    QString getOutput6();
    QString getOutput7();
    QString getOutput8();

    QTabWidget* tabwidget1;

    /* tab 1 -- sets 1 and 2 of CREATE sequence */
    QWidget* headerSpectrum;
    QLabel* idheaderlabel;
    QLineEdit* idheader;
    QLabel* spectrumlabel;
    QButtonGroup* spectrumbuttongroup;
    QRadioButton* monochromaticbutton;
    QLineEdit* energy;
    QLabel* energylabel;
    QRadioButton* polychromaticbutton;
    QLineEdit* nergy;
    QLabel* nergylabel;
    QLineEdit* energy1;
    QLabel* energy1label;
    QLineEdit* percent1;
    QLabel* percent1label;
    QLineEdit* energy2;
    QLabel* energy2label;
    QLineEdit* percent2;
    QLabel* percent2label;
    QLineEdit* energy3;
    QLabel* energy3label;
    QLineEdit* percent3;
    QLabel* percent3label;
    QLineEdit* energy4;
    QLabel* energy4label;
    QLineEdit* percent4;
    QLabel* percent4label;
    QLineEdit* energy5;
    QLabel* energy5label;
    QLineEdit* percent5;
    QLabel* percent5label;
    QLineEdit* energy6;
    QLabel* energy6label;
    QLineEdit* percent6;
    QLabel* percent6label;
    QLineEdit* energy7;
    QLabel* energy7label;
    QLineEdit* percent7;
    QLabel* percent7label;

    /* tab 2 -- set 3 of CREATE sequence */
    QWidget* objects;
    QLabel* objectslabel;
    QComboBox* shape;
    QLineEdit* cx;
    QLineEdit* cy;
    QLineEdit* u;
    QLineEdit* v;
    QLineEdit* ang;
    QLineEdit* den1;
    QLineEdit* deni;
    QLabel* shapelabel;
    QLabel* cxlabel;
    QLabel* cylabel;
    QLabel* ulabel;
    QLabel* vlabel;
    QLabel* anglabel;
    QLabel* den1label;
    QLabel* denilabel;
    QPushButton* addshapebutton;
    QMultiLineEdit* objectsdescription;
    QLineEdit* scale;
    QLabel* lastlabel;
    QLabel* scalelabel;
    
    /* jk 06/13/2008 added variabled to reflect tissue variabilit in snark14*/
    QLineEdit* seedvar;
    QLabel* seedvarlabel;
    QLineEdit* var;
    QLabel* varlabel;
    
    /* tab 3 -- sets 4 and 5 of CREATE sequence */
    QWidget* phantomRaysum;
    QLabel* phantomlabel;
    QRadioButton* phantomaveragebutton;
    QLineEdit* nave1;
    QLabel* nave1label;
    QLineEdit* nelem;
    QLabel* nelemlabel;
    QLineEdit* pixelsize;
    QLabel* pixelsizelabel;
    QLabel* raysumlabel;
    QRadioButton* raysumaveragebutton;
    QLineEdit* nave2;
    QLabel* nave2label;
    QLineEdit* naper1;
    QLabel* naper1label;
    QLineEdit* naper2;
    QLabel* naper2label;
    QLineEdit* naper3;
    QLabel* naper3label;
    QLineEdit* naper4;
    QLabel* naper4label;
    QLineEdit* naper5;
    QLabel* naper5label;
    QLineEdit* naper6;
    QLabel* naper6label;
    QLineEdit* naper7;
    QLabel* naper7label;
    QLineEdit* naper8;
    QLabel* naper8label;
    QLineEdit* naper9;
    QLabel* naper9label;
    QLineEdit* naper10;
    QLabel* naper10label;
    QLineEdit* naper11;
    QLabel* naper11label;
    QLineEdit* naper12;
    QLabel* naper12label;
    QLineEdit* naper13;
    QLabel* naper13label;

    /* tab 4 -- set 6 of CREATE sequence */
    QWidget* geometryRaysums;
    QLabel* geometrylabel;
    QButtonGroup* geometrybuttongroup;
    QRadioButton* parallelbutton;
    QRadioButton* divergentbutton;
    QRadioButton* linogrambutton;
    QButtonGroup* parallelbuttongroup;
    QRadioButton* uniformbutton;
    QRadioButton* variablebutton;
    QButtonGroup* parallelbuttongroup2;
    QRadioButton* stripbutton;
    QRadioButton* linebutton;
    QButtonGroup* divergentbuttongroup;
    QRadioButton* arcbutton;
    QRadioButton* tangentbutton;
    QLineEdit* sourcetoorigin;
    QLabel* sourcetooriginlabel;
    QLineEdit* sourcetodetector;
    QLabel* sourcetodetectorlabel;
    QLabel* raysumslabel;
    QButtonGroup* raysumsbuttongroup;
    QRadioButton* userbutton;
    QLineEdit* userrays;
    QLabel* userrayslabel;
    QRadioButton* programbutton;
    QLineEdit* raysumsnelem;
    QLabel* raysumsnelemlabel;
    QLineEdit* raysumspixelsize;
    QLabel* raysumspixelsizelabel;
    QLineEdit* detectorspacing;
    QLabel* detectorspacinglabel;
    QLabel* angleslabel;
    QButtonGroup* anglesbuttongroup;
    QLineEdit* prjnum;
    QLabel* prjnumlabel;
    QRadioButton* linobutton;
    QRadioButton* equalspacingbutton;
    QLineEdit* firstangle;
    QLabel* firstanglelabel;
    QLineEdit* lastangle;
    QLabel* lastanglelabel;
    QRadioButton* nonebutton;
    //    QMultiLineEdit* angles; // bad idea.  make it a regular line edit
    QLineEdit* angles;

    /* tab 5 -- sets 7 and 8 of CREATE sequence */
    QWidget* measurementRun;
    QLabel* measurementlabel;
    QButtonGroup* measurementbuttongroup;
    QRadioButton* perfectbutton;
    QRadioButton* noisybutton;
    QFrame* noisyframe;
    QCheckBox* quantumbutton;
    QLineEdit* quanmn;
    QLabel* quanmnlabel;
    QLineEdit* quancm;
    QLabel* quancmlabel;
    QLabel* calibrationlabel;
    QComboBox* quanin;
    QLabel* quaninlabel;
    QCheckBox* scatterbutton;
    QLineEdit* sctnpk;
    QLabel* sctnpklabel;
    QLineEdit* sctnwd;
    QLabel* sctnwdlabel;
    QCheckBox* additivebutton;
    QLineEdit* addnmn;
    QLabel* addnmnlabel;
    QLineEdit* addnsd;
    QLabel* addnsdlabel;
    QCheckBox* multiplicativebutton;
    QLineEdit* multnmn;
    QLabel* multnmnlabel;
    QLineEdit* multnsd;
    QLabel* multnsdlabel;
    QLabel* seedlabel;
    QLineEdit* seed;
    QLabel* seedlabel1;
    QLabel* backgroundlabel;
    QLineEdit* backgr1;
    QLabel* backgr1label;
    QLineEdit* backgr2;
    QLabel* backgr2label;
    QLineEdit* backgr3;
    QLabel* backgr3label;
    QLineEdit* backgr4;
    QLabel* backgr4label;
    QLineEdit* backgr5;
    QLabel* backgr5label;
    QLineEdit* backgr6;
    QLabel* backgr6label;
    QLineEdit* backgr7;
    QLabel* backgr7label; 
    QLabel* runlabel;
    QButtonGroup* runbuttongroup;
    QRadioButton* savebutton;
    QRadioButton* modifybutton;
    QRadioButton* nonebutton_2;

    QPushButton* okbutton;
    QPushButton* cancelbutton;
    
    bool israysumaveragepresent;
public slots:
    bool isRaysumAveragePresent();
private slots:
    void addShape();
    void activateMonochromaticFields();
    void activatePolychromaticFields();
    void activatePhantomAverageFields();
    void activateRaysumAverageFields();
    void activateParallelFields();
    void activateDivergentFields();
    void activate__6_3__6_4__6_5( bool enable ); // doesn't need to be a slot really
    void activateLinogramFields();
    void activateUserFields();
    void activateProgramFields();
    void activateEqualSpacingFields();
    void deactivateEqualSpacingFields();
    void deactivateNoisyFields();
    void activateNoisyFields();
    void activateQuantumFields();
    void activateScatterFields();
    void activateAdditiveFields();
    void activateMultiplicativeFields();
    void activateOKButton();
    void checkValues();
};

#endif // CREATEWINDOW2_H
